﻿
using System;
namespace HeuristicLab.ExperimentGeneration.DataAnalysis.ExperimentWizard {
  public partial class SelectAnalysisPage : HeuristicLab.ExperimentGeneration.DataAnalysis.Wizard.WizardPage {
    private const string descMediumScenario = "Support Vector Regression \r\n" +
                                               "Nu: 0.1 ... 0.9 \r\n" +
                                               "Cost: 0.03125 ... 32768 \r\n" +
                                               "Gama: 0.0000610352 ... 64 \r\n" +
                                               "\r\n" +
                                               "Random Forest Regression \r\n" +
                                               "R: 0.1 ... 0.7 \r\n" +
                                               "Number of trees: 250 \r\n" +
                                               "\r\n" +
                                               "Neural Network Regression \r\n" +
                                               "Decay: 0.001 ... 100 \r\n" +
                                               "NodesInFirstHiddenLayer: 1 ... 100 \r\n" +
                                               "\r\n" +
                                               "Offspring Selection Genetic Algorithm \r\n" +
                                               "ComparisonFactorLowerBound: 1 \r\n" +
                                               "MaximumEvaluatedSolutions: 500000 \r\n" +
                                               "MaximumGenerations: 100 \r\n" +
                                               "MutationProbability: 0.15 \r\n" +
                                               "PopulationSize: 500 \r\n" +
                                               "Max. Tree Depth: 8; 12; 17 \r\n" +
                                               "Max. Tree Length: 25; 125; 250 \r\n";


    private DataAnalysisWizardContext context;
    public DataAnalysisWizardContext Context {
      get { return context; }
    }

    public SelectAnalysisPage(DataAnalysisWizardContext context) {
      InitializeComponent();
      this.context = context;
      txtMediumAnalysis.Text = descMediumScenario;
    }

    private void SelectAnalysisPage_SetActive(object sender, System.ComponentModel.CancelEventArgs e) {
      SetWizardButton(Wizard.WizardButtons.Next);
    }

    private void SelectAnalysisPage_WizardNext(object sender, Wizard.WizardPageEventArgs e) {
      if (rbSmall.Checked) {
        context.SelectedAnalysis = rbSmall.Text;
        e.NewPage = "WizardPage";
      } else if (rbMedium.Checked) {
        context.SelectedAnalysis = rbMedium.Text;
        e.NewPage = "MediumAnalysisPage";
      } else if (rbLarge.Checked) {
        context.SelectedAnalysis = rbLarge.Text;
        e.NewPage = "WizardPage";
      }
        //else if (rbCustom.Checked) {
        //  context.SelectedAnalysis = rbCustom.Text;
        //  e.NewPage = "WizardPage";
        //} 
      else {
        throw new SystemException("Undefined data analysis selected.");
      }
    }
  }
}
